
SELECT 
 snapshot_isolation_state, 
 is_read_committed_snapshot_on 
 FROM sys.databases
 WHERE name = 'pubs'

ALTER DATABASE pubs SET ALLOW_SNAPSHOT_ISOLATION OFF
ALTER DATABASE pubs SET READ_COMMITTED_SNAPSHOT OFF

CREATE TRIGGER foo2
ON DATABASE
FOR DDL_SSB_EVENTS
AS
insert tab1 values(eventdata())

create table tab1 (events xml)

create table tab2 (id int)

CREATE TABLE evtTest (id int primary key)

select * from tab1

CREATE TABLE largeFixedValues2 (
 COLUMN1 CHAR(80),   COLUMN2 CHAR(8000) )  -- error

declare @x nvarchar(max)
declare @y nvarchar(max)

set @y = replicate(cast('a' as nvarchar(max)), 600)

set @x = replicate(cast('a' as nvarchar(max)), 5000)
print datalength(@x)

SET @x.WRITE(@y, 5000, 1000)
print datalength(@x)

SET @x.WRITE(@y, 5200, 1000)
print datalength(@x)

SET @x.WRITE(@y, 8700, 1000)
print datalength(@x)



DECLARE @x nvarchar(max)
DECLARE @y nvarchar(max)
SET @y = replicate(cast('a' as nvarchar(max)), 500)
SET @x.WRITE(@y, 0, 500) -- error, can't write to NULL instance
SET @x = replicate(cast('a' as nvarchar(max)), 5000)
PRINT len(@x)        -- prints 5000
SET @x.WRITE(@y, 5000, 500)
PRINT len(@x)        -- prints 5500
SET @x.WRITE(@y, 5000, 995) -- not an error, appends 500
PRINT len(@x)        -- prints 5500
SET @x.WRITE(@y, 5200, 500) -- not an error, replaces 300, appends 200
PRINT len(@x)        -- prints 5700
SET @x.WRITE(@y, 0, 500) -- error, can't write to NULL instance
