
use tempdb
go


declare @a varchar(max)
set @a = replicate(convert(varchar(max),'a'), 12000)
print len(@a)


declare @a varchar(max)
set @a = '123'
set @a = @a + '456'
print @a

-- variables
declare @x varchar(max) -- yes
declare @y varchar(max)
declare @z varchar(max)
-- declare @a text (no)

declare @i int
declare @j bigint

set @x = replicate(convert(varchar(max),'a'), 12000)
set @j = difference(@x, @y)
set @j = len(@x)
print @j
set @j = datalength(@x)
set @y = ltrim(@x)
set @y = left(@x, 1000)
set @y = rtrim(@x)
set @y = upper(@x)
set @y = stuff(@x, 9000, 1000, convert(varchar(max), 'B'))
print ascii(substring(@y, 9005, 1))
go

/*-- dummy proc
create procedure foo(@a text, @b text out, @c int out, @d bigint out)
as
begin
set @c = 1
end
go
--*/


alter procedure foo(@a text, @b text out, @c int out, @d bigint out)
as
begin
-- invalid for parm1
-- set @d = len(@a)
-- set @b = ltrim(@a)
-- set @b = upper(@a)
-- set @b = lower(@a)
-- set @b = left(@a, 9000)
-- set @b = stuff(@a, 9000, 1000, convert(varchar(max), 'B'))
-- difference works with text, only first 8000 bytes significant

set @c = datalength(@a) -- ok
print ascii(substring(@a, 9005, 1)) -- ok
-- char is the opposite of asc
-- like?
end
go

create table t1 (id int, foo  text)
go

-- ok
select col_length('foo', 't1') from t1
go


drop table  t1
go



/*
ASCII
CHAR
CHARINDEX* (no text)
COL_LENGTH*
DATALENGTH* (yes text)
DIFFERENCE
LEFT
LEN*
LOWER
LTRIM
NCHAR
PATINDEX
QUOTENAME
REPLACE
REPLICATE
REVERSE
RIGHT
RTRIM
SOUNDEX
SPACE
STR
STUFF
SUBSTRING* (yes text)
UNICODE
UPPER
+ - concatenation operator
*/

-- encryption functions - no MAX, no text

use pubs
go

drop function function1
drop procedure storedprocedure2
drop assembly sqlserverproject5

create assembly sqlserverproject5
 from 'c:\test\sqlserverproject5.dll'

-- no
create procedure sp2 (@a ntext)
as
external name sqlserverproject5.StoredProcedures.StoredProcedure2

-- yes
create procedure sp2 (@a nvarchar(max))
as
external name sqlserverproject5.StoredProcedures.StoredProcedure2