use Inventory
go

--*********************************************
--*  Show the deployed CLR stored procedure
--*********************************************
select * from sys.assemblies;
select * from sys.procedures where name='ServiceProc'

-- run the initiator

select * from [Inventory Queue];

-- set the breakpoint in VS

--*********************************************
--*  Enable internal activation for [Inventory Queue]
--*********************************************
alter queue [Inventory Queue]
	with activation (
		status = on,
		procedure_name = ServiceProc,
		max_queue_readers = 2,
		execute as self);
go

-- exec ServiceProc

use master
