use Inventory
go

--*********************************************
--*  Disable internal activation for [Inventory Queue]
--*********************************************
alter queue [Inventory Queue]
	with activation (drop);
go

--*********************************************
--*  Create the event notification service
--*********************************************
create queue [ExternalActivatorQueue];
create service [ExternalActivator] 
	on queue [ExternalActivatorQueue]
	 ([http://schemas.microsoft.com/SQL/Notifications/PostEventNotification]);

--*********************************************
--*  Subscribe to the QUEUE_ACTIVATION event on
--*  [Inventory Queue]
--*********************************************
create event notification en 
	on queue [Inventory Queue] 
	for queue_activation 
	to service 'ExternalActivator', 'current database';

--drop event notification en on queue [Inventory Queue]
use master
go